Subject: Re: [PATCH] tty: xilinx_uartps: Really fix id assignment

From: Maarten Brock <[email-masked]>
Date: Mon, 13 Jul 2020 18:08:08 +0200

On 2020-07-13 14:10, Helmut Grohne wrote:
> Hi Michal,
> 
> On Mon, Jul 13, 2020 at 01:49:38PM +0200, Michal Simek wrote:
>> On 13. 07. 20 9:11, Helmut Grohne wrote:
>> > Let me try to enumerate those I know:
>> >
>> > uart0    | uart1    | console | remark
>> > ---------+----------+---------+----------
>> > serial0  | serial1  | ttyPS0  | regular case
>> > serial0  | serial1  | ttyPS1  | normal assignment, second console
>> > serial1  | serial0  | ttyPS0  | -> Jan Kiszka, broken since revert
>> > disabled | serial0  | ttyPS0  | use only uart1 as serial0
>> > serial0  | disabled | ttyPS0  | regular case with uart1 disabled
>> >
>> > Out of these, I'm actively using configurations 3 and 4.
>> >
>> > Which of these scenarios do you test already?
>> 
>> For above we are missing also others
>> serial1 | serial0 | ttyPS1
>> disabled| serial1 | ttyPS1
> 
> Is it actually possible to have ttyPS1, but no ttyPS0? I think I tried
> doing that earlier and it resulted in there being ttyPS0, but no 
> ttyPS1.

What if you also have a 16550 (in the PL) and give it the serial0 alias?
Or a UARTlite? The serialN alias is inappropriate to set the number for
ttyPSn. How are you supposed to create all of ttyPS0, ttyS0 and ttyUL0
using a single serial0 alias?

>> serial1 | disables | ttyPS0
> 
> I'm not sure what this is supposed to mean. When there is no serial0
> alias, I'd expect ttyPS0 to be missing. However as indicated above that
> is not what happens in practice. So either of these two configurations
> seems invalid to me.
> 
>> All of these above are just not setting any console= on bootargs.
> 
> We usually set the console= assignment on bootargs.
> 
>> It means mix of these combinations is tested regularly but not all of
>> them. Do you see any other combination which is not supported?
> 
> I'm not aware of further relevant combinations.
> 
> Can we maybe trim down the matrix somehow? In my context, the need for
> swapping the serial aliases arises from a limitation in u-boot-xlnx and
> the desire to use one dtb for both linux and u-boot. It requires that
> the serial0 alias is the console. Are there other reasons to swap them?
> If not, maybe fixing u-boot would be an option?
> 
> Helmut

I think that it would be better if u-boot used a "console" alias.

Maarten

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel